<template>
  <div class="header">
    <div class="header-container">
      <b-row class="m-0">
        <b-col class="header-brand col col-12 col-sm-3 col-lg-2 elm-center">
          <router-link
            :to="{ name: 'Dashboard' }"
            class="text1 color-white2 font-weight-bold"
          >
            BISAD <span class="color-red2"> |||</span>
          </router-link>
        </b-col>
        <b-col class="header-bar col d-flex align-items-center">
          <div class="row m-0 w-100">
            <div class="col">
              <transition name="fade" mode="out-in">
                <div v-if="userStateData">
                  <span class="font-weight-bold color-red3">
                    {{ userDataData }}
                  </span>
                  <span v-for="(list, count) in routerList" :key="count">
                    <span v-if="list != ''"> > {{ list }} </span>
                  </span>
                </div>
              </transition>
            </div>
            <div class="col text-right singout" @click="signout()">
              <transition name="fade" mode="out-in">
                <div v-if="userStateData" class="font-weight-bold">
                  SIGN <span class="color-red1">OUT</span>
                </div>
              </transition>
            </div>
          </div>
        </b-col>
      </b-row>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import Component from "vue-class-component";
import { Watch } from "vue-property-decorator";
import { State, Action, Getter } from "vuex-class";
import { AuthState, UpdateState } from "../store/auth/types";
import "@scss/_header.scss";

const namespace: string = "auth";

@Component({
  name: "Header"
})
export default class Header extends Vue {
  // Data
  routerList: any = null;

  // Store
  @State("auth") auth!: AuthState;
  @Action("signout", { namespace }) signout!: any;
  @Getter("userStateData", { namespace }) userStateData!: string;
  @Getter("userDataData", { namespace }) userDataData!: string;
  @Action("fetchUser", { namespace }) fetchUser!: any;

  // Watch
  @Watch("$route", { immediate: true, deep: true })
  updateRouteData() {
    this.routerList = this.$router.currentRoute.fullPath.split("/");
  }

  mounted() {
    this.fetchUser();
  }
}
</script>